// Oleg Petruny proprietary.

#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Actor.h"
#include "UObject/ScriptInterface.h"

#include "Interactable.generated.h"

UCLASS(Abstract, MinimalAPI, Blueprintable, BlueprintType)
class AInteractable : public AActor
{
    GENERATED_BODY()

public:
    UFUNCTION(BlueprintNativeEvent, BlueprintCallable)
    TArray<TSubclassOf<class UInteractableComponent>> GetInteractableComponents();
    virtual TArray<TSubclassOf<class UInteractableComponent>> GetInteractableComponents_Implementation()
        PURE_VIRTUAL(AInteractable::GetInteractableComponents_Implementation, return {};);
};

