// Oleg Petruny proprietary.

#pragma once

#include "Components/SceneComponent.h"
#include "CoreMinimal.h"

#include "InteractableActivator.generated.h"

DECLARE_DELEGATE_OneParam(FInteractableActivated, class AInteractable*);
DECLARE_DELEGATE_OneParam(FInteractableDeactivated, class AInteractable*);

UCLASS(Abstract, Blueprintable, BlueprintType)
class UInteractableActivator : public USceneComponent
{
    GENERATED_BODY()

public:
    UInteractableActivator(const FObjectInitializer& ObjectInitializer);
    virtual void TickComponent(float DeltaTime, enum ELevelTick TickType, FActorComponentTickFunction* ThisTickFunction) override;

    FInteractableActivated interactableActivatedDelegate;
    FInteractableActivated interactableDeactivatedDelegate;

protected:
    UFUNCTION(BlueprintNativeEvent, BlueprintCallable)
    inline void Scan();
    inline virtual void Scan_Implementation() PURE_VIRTUAL(UInteractableActivator::Scan_Implementation, );

    UPROPERTY(EditDefaultsOnly)
    float scanDistance = 200;

    class UWorld* world;
    class APlayerBase* player;
    enum ECollisionChannel collisionChannel;
};
