// Oleg Petruny proprietary.

#pragma once

#include "CoreMinimal.h"
#include "InputMappingContext.h"
#include "UObject/Interface.h"

#include "InteractableActivator.h"

#include "InteractableComponent.generated.h"

UCLASS(Abstract, Blueprintable, BlueprintType)
class UInteractableComponent : public UActorComponent
{
    GENERATED_BODY()

public:
    UFUNCTION(BlueprintNativeEvent, BlueprintCallable)
    const FString GetName();
    virtual const FString GetName_Implementation()
        PURE_VIRTUAL(UInteractableComponent::GetInteractionName_Implementation, return "NONE";);

    UFUNCTION(BlueprintNativeEvent, BlueprintCallable)
    const TArray<TSubclassOf<UInteractableActivator>> GetActivators();
    virtual const TArray<TSubclassOf<UInteractableActivator>> GetActivators_Implementation()
        PURE_VIRTUAL(UInteractableComponent::GetActivatorsZ_Implementation,
            TArray<TSubclassOf<UInteractableActivator>> _activators{}; return _activators;);
};
