#pragma once

// Oleg Petruny proprietary.

#pragma once

#include "CoreMinimal.h"
#include "UObject/Object.h"

#include "WidgetsManager.generated.h"

UCLASS(Blueprintable)
class UWidgetsManager : public UObject
{
    GENERATED_BODY()

public:
    void Init();

    void HideOverlayWidgets();
    void ShowOverlayWidgets();
    void UpdateOverlayWidgetsOwner();

    void ShowInteractionHints(class AInteractable* interactable);

protected:
    UPROPERTY(EditDefaultsOnly)
    TArray<TSubclassOf<class UUserWidget>> permaOverlayWidgets; // never hidden
    TArray<TWeakObjectPtr<class UUserWidget>> permaOverlayWidgetsInstances;

    UPROPERTY(EditDefaultsOnly)
    TArray<TSubclassOf<class UUserWidget>> overlayWidgets; // hidden in pause
    TArray<TWeakObjectPtr<class UUserWidget>> overlayWidgetsInstances;
};
